<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/facnb.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>facnb.c</h1><a href="facnb_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: facnb.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="facnb_8c.html#aca1b29888c9336db98e1924813a45f90">00030</a> <span class="preprocessor">#define USEQSORT</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#ifdef USEQSORT</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a><a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">00034</a> <span class="keywordtype">int</span> *<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="facnb_8c.html#a080f2d81423b15d9aa4263dad5703865">00036</a> <span class="keywordtype">int</span> <a class="code" href="facnb_8c.html#a080f2d81423b15d9aa4263dad5703865">CompareFaces</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* v1,<span class="keyword">const</span> <span class="keywordtype">void</span>* v2) {
<a name="l00037"></a>00037   <span class="keyword">const</span> <span class="keywordtype">int</span>* t1=(<span class="keyword">const</span> <span class="keywordtype">int</span>*)v1;
<a name="l00038"></a>00038   <span class="keyword">const</span> <span class="keywordtype">int</span>* t2=(<span class="keyword">const</span> <span class="keywordtype">int</span>*)v2;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <span class="keywordflow">if</span> (<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t1+0]&lt;<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t2+0]) <span class="keywordflow">return</span> -1;
<a name="l00041"></a>00041   <span class="keywordflow">if</span> (<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t1+0]&gt;<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t2+0]) <span class="keywordflow">return</span> 1;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t1+1]&lt;<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t2+1]) <span class="keywordflow">return</span> -1;
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t1+1]&gt;<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t2+1]) <span class="keywordflow">return</span> -1;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t1+2]&lt;<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t2+2]) <span class="keywordflow">return</span> -1;
<a name="l00047"></a>00047   <span class="keywordflow">if</span> (<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t1+2]&gt;<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>* *t2+2]) <span class="keywordflow">return</span> -1;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="comment">/* we should never reach this point */</span>
<a name="l00050"></a>00050   assert(0==1);
<a name="l00051"></a>00051   <span class="keywordflow">return</span> 0;
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 <span class="preprocessor">#endif</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a><a class="code" href="init_8h.html#ab880c52c1f93378088ef1e53763aa916">00055</a> <span class="keywordtype">int</span> <a class="code" href="facnb_8c.html#ab880c52c1f93378088ef1e53763aa916">FacNB</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="keywordtype">int</span>  t_facvert[<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>];
<a name="l00058"></a>00058   <span class="keywordtype">int</span>  t_elevs[<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>];
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordtype">int</span> rank,size;
<a name="l00063"></a>00063   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00064"></a>00064   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="keywordflow">if</span> (rank) {
<a name="l00067"></a>00067     gdata-&gt;<a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">ln_bnd_fac</a>=0;
<a name="l00068"></a>00068     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00069"></a>00069   }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">/* get connectivity matrix of elements */</span>
<a name="l00072"></a>00072   <span class="comment">/* recommended size (METIS manual):</span>
<a name="l00073"></a>00073 <span class="comment">     sizeof(ia): (n_ele+1)</span>
<a name="l00074"></a>00074 <span class="comment">     sizeof(ja): 4*n_ele</span>
<a name="l00075"></a>00075 <span class="comment">  */</span>
<a name="l00076"></a>00076   <span class="keywordtype">int</span> *ia,*ja;
<a name="l00077"></a>00077   ierr = <a class="code" href="mesh2dual_8c.html#a072403ed5e4bbd16fd845d52009d1270">Mesh2Dual</a>(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>,&amp;ia,&amp;ja);CHKERRQ(ierr);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>+1;i++) {
<a name="l00080"></a>00080     <span class="keywordflow">if</span> (ia[i]-ia[i-1]&gt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>) {
<a name="l00081"></a>00081       SETERRQ2(PETSC_ERR_MEMC,<span class="stringliteral">&quot;Found element with %i neighbors (&gt;NF)!\n&quot;</span>,ia[i]-ia[i-1],<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>);
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083   }
<a name="l00084"></a>00084   assert(ia[gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>]&lt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">/* check for array overrun */</span>
<a name="l00087"></a>00087   assert(ia[gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>]&lt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="keywordtype">int</span> *elefac;
<a name="l00090"></a>00090   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;elefac);CHKERRQ(ierr);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordtype">int</span> *facnb;
<a name="l00093"></a>00093   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*2*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;facnb);CHKERRQ(ierr);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*2*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00096"></a>00096     facnb[i]=<a class="code" href="griddata_8h.html#a23a3109d94031a21452ba531f1544898">C_UNK</a>;
<a name="l00097"></a>00097   }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">/* each element has NF faces,</span>
<a name="l00100"></a>00100 <span class="comment">     the last entry in ia (ia[gdata-&gt;n_ele])</span>
<a name="l00101"></a>00101 <span class="comment">     gives us the total number of neighbours,</span>
<a name="l00102"></a>00102 <span class="comment">     each pair of neighbours appears twice,</span>
<a name="l00103"></a>00103 <span class="comment">     thus we have ia[gdata-&gt;n_ele]/2 shared faces,</span>
<a name="l00104"></a>00104 <span class="comment">     thus the total number of faces is</span>
<a name="l00105"></a>00105 <span class="comment">     NF*n_ele-ia[gdata-&gt;n_ele]/2</span>
<a name="l00106"></a>00106 <span class="comment">  */</span>
<a name="l00107"></a>00107   <span class="keywordtype">int</span> n_fac;
<a name="l00108"></a>00108   n_fac=<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>*gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>-ia[gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>]/2;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="preprocessor">#ifndef USEQSORT</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>  <span class="keywordtype">int</span> *<a class="code" href="facnb_8c.html#aae3b5f9e645a30cf7e75ffde9302c9c4">facvert</a>;
<a name="l00112"></a>00112 <span class="preprocessor">#endif</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>  ierr = PetscMalloc(n_fac*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;facvert);CHKERRQ(ierr);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordtype">int</span> t_facmax;
<a name="l00116"></a>00116   t_facmax=0;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   ierr = PetscGetTime(&amp;t_t2);CHKERRQ(ierr);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Searching for surface faces and nodes...\n&quot;</span>);
<a name="l00121"></a>00121   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00122"></a>00122     ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(i,gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>,10);
<a name="l00123"></a>00123     <span class="comment">/* get number of neighbours for current element */</span>
<a name="l00124"></a>00124     <span class="keywordtype">int</span> t_nnb;
<a name="l00125"></a>00125     t_nnb=ia[i+1]-ia[i];
<a name="l00126"></a>00126 
<a name="l00127"></a>00127     <span class="comment">/* get nodes */</span>
<a name="l00128"></a>00128     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>; j++) {
<a name="l00129"></a>00129       t_elevs[j]=gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>[NV*i+j];
<a name="l00130"></a>00130 <span class="comment">/*</span>
<a name="l00131"></a>00131 <span class="comment">      if (mergepoints) {</span>
<a name="l00132"></a>00132 <span class="comment">        t_elevs[j]=PetscMin(gdata-&gt;elevert[NV*i+j],gdata-&gt;vertcoupl[gdata-&gt;elevert[NV*i+j]]);</span>
<a name="l00133"></a>00133 <span class="comment">      }</span>
<a name="l00134"></a>00134 <span class="comment">*/</span>
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     <span class="comment">/* sort nodes */</span>
<a name="l00138"></a>00138     ierr = PetscSortInt(NV,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)t_elevs);CHKERRQ(ierr);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     <span class="comment">/* get facvert */</span>
<a name="l00141"></a>00141     t_facvert[0]  = t_elevs[0];  <span class="comment">/* first face */</span>
<a name="l00142"></a>00142     t_facvert[1]  = t_elevs[1];
<a name="l00143"></a>00143     t_facvert[2]  = t_elevs[2];
<a name="l00144"></a>00144     t_facvert[3]  = t_elevs[3];
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     t_facvert[4]  = t_elevs[0];  <span class="comment">/* second face */</span>
<a name="l00147"></a>00147     t_facvert[5]  = t_elevs[1];
<a name="l00148"></a>00148     t_facvert[6]  = t_elevs[3];
<a name="l00149"></a>00149     t_facvert[7]  = t_elevs[2];
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     t_facvert[8]  = t_elevs[0];  <span class="comment">/* third face */</span>
<a name="l00152"></a>00152     t_facvert[9]  = t_elevs[2];
<a name="l00153"></a>00153     t_facvert[10] = t_elevs[3];
<a name="l00154"></a>00154     t_facvert[11] = t_elevs[1];
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     t_facvert[12] = t_elevs[1];  <span class="comment">/* fourth face */</span>
<a name="l00157"></a>00157     t_facvert[13] = t_elevs[2];
<a name="l00158"></a>00158     t_facvert[14] = t_elevs[3];
<a name="l00159"></a>00159     t_facvert[15] = t_elevs[0];
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="comment">/* process all NF faces */</span>
<a name="l00162"></a>00162     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>; j++) {
<a name="l00163"></a>00163       <span class="keywordtype">int</span> t_found;
<a name="l00164"></a>00164       t_found=0;
<a name="l00165"></a>00165 
<a name="l00166"></a>00166       <span class="comment">/* search the neighbours */</span>
<a name="l00167"></a>00167       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k=0; k&lt;t_nnb; k++) {
<a name="l00168"></a>00168         <span class="comment">/* get the id of our neighbour */</span>
<a name="l00169"></a>00169         <span class="keywordtype">int</span> t_nbid;
<a name="l00170"></a>00170         t_nbid=ja[ia[i]+k];
<a name="l00171"></a>00171 
<a name="l00172"></a>00172         <span class="comment">/* find shared nodes */</span>
<a name="l00173"></a>00173         <span class="keywordtype">int</span> x,vshared[NV];
<a name="l00174"></a>00174         x=<a class="code" href="tettri_8c.html#aa5edf1170e954574fb88dff3cafac7c1">tetnb</a>(gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+NV*i,gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>+NV*t_nbid,vshared);
<a name="l00175"></a>00175         <span class="comment">/* we assume we get neighbors sharing a face - i.e. 3 nodes - from Metis */</span>
<a name="l00176"></a>00176         assert(x==<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178         <span class="keywordflow">if</span> ((t_facvert[NV*j+0]==vshared[0]) &amp;&amp;
<a name="l00179"></a>00179             (t_facvert[NV*j+1]==vshared[1]) &amp;&amp;
<a name="l00180"></a>00180             (t_facvert[NV*j+2]==vshared[2])
<a name="l00181"></a>00181            ) {
<a name="l00182"></a>00182 
<a name="l00183"></a>00183            t_found=1;
<a name="l00184"></a>00184 
<a name="l00185"></a>00185           <span class="comment">/* if the id of the neighbour is smaller than ours</span>
<a name="l00186"></a>00186 <span class="comment">             then its faces have already been processed */</span>
<a name="l00187"></a>00187           <span class="keywordflow">if</span> (t_nbid&lt;i) {
<a name="l00188"></a>00188             <span class="comment">/* search for our id among neighbours of t_nbid */</span>
<a name="l00189"></a>00189             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> m=0; m&lt;NF; m++) {
<a name="l00190"></a>00190               <span class="keywordflow">if</span> (facnb[elefac[t_nbid*NF+m]*2+1]==i) {
<a name="l00191"></a>00191                 elefac[i*NF+j]=elefac[t_nbid*NF+m];
<a name="l00192"></a>00192                 <span class="keywordflow">break</span>;
<a name="l00193"></a>00193               }
<a name="l00194"></a>00194             }
<a name="l00195"></a>00195           }
<a name="l00196"></a>00196           <span class="comment">/* else we have to register a new face */</span>
<a name="l00197"></a>00197           <span class="keywordflow">else</span> {
<a name="l00198"></a>00198             facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+0]=vshared[0];
<a name="l00199"></a>00199             facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+1]=vshared[1];
<a name="l00200"></a>00200             facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+2]=vshared[2];
<a name="l00201"></a>00201             facnb[t_facmax*2+0]=i;
<a name="l00202"></a>00202             facnb[t_facmax*2+1]=t_nbid;
<a name="l00203"></a>00203             elefac[i*NF+j]=t_facmax;
<a name="l00204"></a>00204             t_facmax++;
<a name="l00205"></a>00205           }
<a name="l00206"></a>00206           <span class="keywordflow">break</span>;
<a name="l00207"></a>00207         }
<a name="l00208"></a>00208         <span class="keywordflow">if</span> (t_found) <span class="keywordflow">break</span>;
<a name="l00209"></a>00209       }
<a name="l00210"></a>00210       <span class="comment">/* if we cannot find a neighbour, it must be on the surface */</span>
<a name="l00211"></a>00211       <span class="keywordflow">if</span> (!t_found) {
<a name="l00212"></a>00212         <span class="comment">/* check orientation (normal vector should point outwards),</span>
<a name="l00213"></a>00213 <span class="comment">           this ensures, that surface triangles have the correct</span>
<a name="l00214"></a>00214 <span class="comment">           orientation</span>
<a name="l00215"></a>00215 <span class="comment">        */</span>
<a name="l00216"></a>00216         <span class="comment">/* if a surface triangle is found the element must have</span>
<a name="l00217"></a>00217 <span class="comment">           less than NF neighbors</span>
<a name="l00218"></a>00218 <span class="comment">        */</span>
<a name="l00219"></a>00219         assert(t_nnb&lt;NF);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221         PetscReal *x1,*x2,*x3,*x4;
<a name="l00222"></a>00222         x1=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_facvert[NV*j+0])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00223"></a>00223         x2=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_facvert[NV*j+1])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00224"></a>00224         x3=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_facvert[NV*j+2])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00225"></a>00225         x4=gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>+(t_facvert[NV*j+3])*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227         facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+0]=t_facvert[NV*j+0];
<a name="l00228"></a>00228         <span class="comment">/* proper orientation */</span>
<a name="l00229"></a>00229         <span class="keywordflow">if</span> (<a class="code" href="init_8h.html#ad362da888961433eb994e6a5bc0c818d">tetvol</a>(x1,x2,x3,x4)&lt;0.0) {
<a name="l00230"></a>00230           facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+1]=t_facvert[NV*j+1];
<a name="l00231"></a>00231           facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+2]=t_facvert[NV*j+2];
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233         <span class="comment">/* swap second and third index vertex id */</span>
<a name="l00234"></a>00234         <span class="keywordflow">else</span> {
<a name="l00235"></a>00235           facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+1]=t_facvert[NV*j+2];
<a name="l00236"></a>00236           facvert[t_facmax*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>+2]=t_facvert[NV*j+1];
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238         facnb[t_facmax*2+0]=i;
<a name="l00239"></a>00239         facnb[t_facmax*2+1]=<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>;
<a name="l00240"></a>00240         elefac[i*NF+j]=t_facmax;
<a name="l00241"></a>00241         t_facmax++;
<a name="l00242"></a>00242       }
<a name="l00243"></a>00243     }
<a name="l00244"></a>00244   }
<a name="l00245"></a>00245   ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(1,1,10);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   PetscLogDouble t_t3;
<a name="l00248"></a>00248   ierr = PetscGetTime(&amp;t_t3);CHKERRQ(ierr);
<a name="l00249"></a>00249   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00250"></a>00250     <span class="stringliteral">&quot;Search for surface faces and nodes took %g s = %g min\n&quot;</span>,
<a name="l00251"></a>00251     t_t3-t_t2,
<a name="l00252"></a>00252     (t_t3-t_t2)/60.0
<a name="l00253"></a>00253   );
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>  PetscTruth flg;
<a name="l00257"></a>00257   <span class="keywordtype">int</span> mergepoints;
<a name="l00258"></a>00258   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-hdemag_mergepoints&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;mergepoints,&amp;flg);CHKERRQ(ierr);
<a name="l00259"></a>00259   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00260"></a>00260     mergepoints=1;
<a name="l00261"></a>00261     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00262"></a>00262       <span class="stringliteral">&quot;Option -hdemag_mergepoints not found, using default value: %i\n&quot;</span>,
<a name="l00263"></a>00263       mergepoints
<a name="l00264"></a>00264     );
<a name="l00265"></a>00265   }
<a name="l00266"></a>00266   <span class="keywordflow">if</span> (gdata-&gt;vertcoupl==PETSC_NULL) {
<a name="l00267"></a>00267     mergepoints=0;
<a name="l00268"></a>00268     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;No coupled vertices found, setting -hdemag_mergepoints %i!\n&quot;</span>,mergepoints);
<a name="l00269"></a>00269   }
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="keywordtype">int</span> t_cnt;
<a name="l00272"></a>00272   t_cnt=0;
<a name="l00273"></a>00273   <span class="keywordflow">if</span> (mergepoints) {
<a name="l00274"></a>00274     <span class="comment">/* update facvert array with coupled nodes */</span>
<a name="l00275"></a>00275     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_fac;i++) {
<a name="l00276"></a>00276       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>;j++) {
<a name="l00277"></a>00277         <span class="keywordflow">if</span> (gdata-&gt;vertcoupl[facvert[NN*i+j]]&gt;=0) {
<a name="l00278"></a>00278           <span class="comment">/* use main coupled node (lowest id) */</span>
<a name="l00279"></a>00279           facvert[NN*i+j]=PetscMin(facvert[NN*i+j],gdata-&gt;vertcoupl[facvert[NN*i+j]]);
<a name="l00280"></a>00280         }
<a name="l00281"></a>00281       }
<a name="l00282"></a>00282 <span class="preprocessor">#define swap(a,b) {int tswap;tswap=a;a=b;b=tswap;}</span>
<a name="l00283"></a>00283 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (facvert[NN*i+0]&gt;facvert[NN*i+1]) {
<a name="l00284"></a>00284         swap(facvert[NN*i+0],facvert[NN*i+1]);
<a name="l00285"></a>00285         swap(facvert[NN*i+1],facvert[NN*i+2]);
<a name="l00286"></a>00286       }
<a name="l00287"></a>00287       <span class="keywordflow">if</span> (facvert[NN*i+0]&gt;facvert[NN*i+2]) {
<a name="l00288"></a>00288         swap(facvert[NN*i+0],facvert[NN*i+1]);
<a name="l00289"></a>00289         swap(facvert[NN*i+1],facvert[NN*i+2]);
<a name="l00290"></a>00290       }
<a name="l00291"></a>00291       <span class="keywordflow">if</span> (facvert[NN*i+0]&gt;facvert[NN*i+1]) {
<a name="l00292"></a>00292         swap(facvert[NN*i+0],facvert[NN*i+1]);
<a name="l00293"></a>00293         swap(facvert[NN*i+1],facvert[NN*i+2]);
<a name="l00294"></a>00294       }
<a name="l00295"></a>00295     }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Searching for coupled faces/nodes...\n&quot;</span>);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299     <span class="keywordtype">int</span> nsfac=0;
<a name="l00300"></a>00300     <span class="keywordtype">int</span> *sfac;
<a name="l00301"></a>00301     ierr = PetscMalloc(n_fac*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;sfac);CHKERRQ(ierr);
<a name="l00302"></a>00302 
<a name="l00303"></a>00303     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_fac;i++) {
<a name="l00304"></a>00304       <span class="keywordflow">if</span> (facnb[i*2+1]!=<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a> ||
<a name="l00305"></a>00305           gdata-&gt;vertcoupl[facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*i+0]]==-1 ||
<a name="l00306"></a>00306           gdata-&gt;vertcoupl[facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*i+1]]==-1 ||
<a name="l00307"></a>00307           gdata-&gt;vertcoupl[facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*i+2]]==-1) <span class="keywordflow">continue</span>;
<a name="l00308"></a>00308 
<a name="l00309"></a>00309       sfac[nsfac]=i;
<a name="l00310"></a>00310       nsfac++;
<a name="l00311"></a>00311     }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 <span class="preprocessor">#ifdef USEQSORT</span>
<a name="l00314"></a>00314 <span class="preprocessor"></span>    PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Sorting surface triangles...\n&quot;</span>);
<a name="l00315"></a>00315     qsort(sfac,nsfac,<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),<a class="code" href="facnb_8c.html#a080f2d81423b15d9aa4263dad5703865">CompareFaces</a>);
<a name="l00316"></a>00316 <span class="preprocessor">#endif</span>
<a name="l00317"></a>00317 <span class="preprocessor"></span>
<a name="l00318"></a>00318     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Checking %i coupled faces/nodes...\n&quot;</span>,nsfac);
<a name="l00319"></a>00319 
<a name="l00320"></a>00320     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i2=0;i2&lt;nsfac-1;i2++) {
<a name="l00321"></a>00321       ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(i2,nsfac-1,10);
<a name="l00322"></a>00322 
<a name="l00323"></a>00323       <span class="keywordtype">int</span> i;
<a name="l00324"></a>00324       i=sfac[i2];
<a name="l00325"></a>00325 
<a name="l00326"></a>00326       <span class="comment">/* search all other boundary faces */</span>
<a name="l00327"></a>00327       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> k2=i2+1;k2&lt;nsfac;k2++) {
<a name="l00328"></a>00328 
<a name="l00329"></a>00329         <span class="keywordtype">int</span> k;
<a name="l00330"></a>00330         k=sfac[k2];
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="preprocessor">#ifdef USEQSORT</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*k+0]&gt;facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*i+0]) <span class="keywordflow">break</span>;
<a name="l00334"></a>00334 <span class="preprocessor">#endif</span>
<a name="l00335"></a>00335 <span class="preprocessor"></span>        <span class="comment">/* if all three vertices are coupled */</span>
<a name="l00336"></a>00336         <span class="comment">/* we need to check only three cases, because</span>
<a name="l00337"></a>00337 <span class="comment">           faces are oriented to give positive volume</span>
<a name="l00338"></a>00338 <span class="comment">           and our coupled faces must be oppositely oriented</span>
<a name="l00339"></a>00339 <span class="comment">           and vertices are sorted</span>
<a name="l00340"></a>00340 <span class="comment">        */</span>
<a name="l00341"></a>00341         <span class="keywordflow">if</span> (
<a name="l00342"></a>00342           facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*i+0]==facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*k+0] &amp;&amp;
<a name="l00343"></a>00343           facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*i+1]==facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*k+2] &amp;&amp;
<a name="l00344"></a>00344           facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*i+2]==facvert[<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*k+1]
<a name="l00345"></a>00345           ) {
<a name="l00346"></a>00346           <span class="comment">/* mark faces as interior but coupled */</span>
<a name="l00347"></a>00347           facnb[i*2+1]=facnb[k*2+0];
<a name="l00348"></a>00348           facnb[k*2+1]=facnb[i*2+0];
<a name="l00349"></a>00349 
<a name="l00350"></a>00350           t_cnt+=2;
<a name="l00351"></a>00351           <span class="keywordflow">break</span>;
<a name="l00352"></a>00352         }
<a name="l00353"></a>00353       }
<a name="l00354"></a>00354     }
<a name="l00355"></a>00355     ierr = <a class="code" href="progressbar_8c.html#afac4bb91f0e22a14a209a0f60113654d">ProgressBar</a>(1,1,10);
<a name="l00356"></a>00356 
<a name="l00357"></a>00357     ierr = PetscFree(sfac);CHKERRQ(ierr);
<a name="l00358"></a>00358 
<a name="l00359"></a>00359     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Retagged %i coupled surfaces\n&quot;</span>,t_cnt);
<a name="l00360"></a>00360   }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362   t_t2=t_t3;
<a name="l00363"></a>00363   ierr = PetscGetTime(&amp;t_t3);CHKERRQ(ierr);
<a name="l00364"></a>00364   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00365"></a>00365     <span class="stringliteral">&quot;Search for coupled faces/nodes took %g s = %g min\n&quot;</span>,
<a name="l00366"></a>00366     t_t3-t_t2,
<a name="l00367"></a>00367     (t_t3-t_t2)/60.0
<a name="l00368"></a>00368   );
<a name="l00369"></a>00369 <span class="preprocessor">#endif</span>
<a name="l00370"></a>00370 <span class="preprocessor"></span>
<a name="l00371"></a>00371   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>);CHKERRQ(ierr);
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   <span class="comment">/* reset boundary indicators */</span>
<a name="l00374"></a>00374   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>;i++) {
<a name="l00375"></a>00375     gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[i]=<a class="code" href="griddata_8h.html#af23ac2ffd709eb569a1f0c98d06be299">C_INT</a>;
<a name="l00376"></a>00376   }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   <span class="comment">/* set boundary indicators and count boundary vertices */</span>
<a name="l00379"></a>00379   gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>=0;
<a name="l00380"></a>00380   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_fac;i++) {
<a name="l00381"></a>00381     <span class="keywordflow">if</span> (facnb[i*2+1]==<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>) {
<a name="l00382"></a>00382       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>;j++) {
<a name="l00383"></a>00383         <span class="keywordtype">int</span> k;
<a name="l00384"></a>00384         k=facvert[NN*i+j];
<a name="l00385"></a>00385 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00386"></a>00386 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (mergepoints &amp;&amp; gdata-&gt;vertcoupl[k]&gt;=0) {
<a name="l00387"></a>00387           <span class="comment">/* check that k is the main coupling node (lowest id) as set above */</span>
<a name="l00388"></a>00388           assert(k&lt;gdata-&gt;vertcoupl[k]);
<a name="l00389"></a>00389         }
<a name="l00390"></a>00390 <span class="preprocessor">#endif</span>
<a name="l00391"></a>00391 <span class="preprocessor"></span>        <span class="comment">/* avoid counting vertices twice */</span>
<a name="l00392"></a>00392         <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[k]==<a class="code" href="griddata_8h.html#af23ac2ffd709eb569a1f0c98d06be299">C_INT</a>) {
<a name="l00393"></a>00393           gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[k]=<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>;
<a name="l00394"></a>00394           gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>++;
<a name="l00395"></a>00395         }
<a name="l00396"></a>00396       }
<a name="l00397"></a>00397     }
<a name="l00398"></a>00398   }
<a name="l00399"></a>00399   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00400"></a>00400     <span class="stringliteral">&quot;Boundary matrix: %i vertices, %g matrix elements, %i MB \n&quot;</span>,
<a name="l00401"></a>00401     gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,
<a name="l00402"></a>00402     1.0*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>,
<a name="l00403"></a>00403     gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024*gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>/1024*<span class="keyword">sizeof</span>(PetscReal)+1
<a name="l00404"></a>00404   );
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="comment">/* count boundary faces */</span>
<a name="l00407"></a>00407   gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>=0;
<a name="l00408"></a>00408   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a45e64fa5ec485379f8171edbd95c79d9">n_ele</a>;i++) {
<a name="l00409"></a>00409     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a67a76e80830266d0c77e06b82a55fd0b">NF</a>;j++) {
<a name="l00410"></a>00410       <span class="keywordflow">if</span> (facnb[elefac[i*NF+j]*2+1]==<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>) {
<a name="l00411"></a>00411         gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>++;
<a name="l00412"></a>00412       }
<a name="l00413"></a>00413     }
<a name="l00414"></a>00414   }
<a name="l00415"></a>00415   gdata-&gt;<a class="code" href="structGridData.html#af59cf93f7a91c270b9f07c2bf2453e25">ln_bnd_fac</a>=gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>;
<a name="l00416"></a>00416   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Number of boundary faces: %i\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">/* store data of boundary faces */</span>
<a name="l00419"></a>00419   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>*<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>);CHKERRQ(ierr);
<a name="l00420"></a>00420   <span class="keywordtype">int</span> t_cnt2;
<a name="l00421"></a>00421   t_cnt2=0;
<a name="l00422"></a>00422   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_fac;i++) {
<a name="l00423"></a>00423     <span class="keywordflow">if</span> (facnb[i*2+1]==<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>) {
<a name="l00424"></a>00424       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#a170755e30c36be4904106b7bb279b1ec">NN</a>;j++) {
<a name="l00425"></a>00425         gdata-&gt;<a class="code" href="structGridData.html#a018ce7264f478c6eae964c4a753a796b">bndfacvert</a>[t_cnt2*NN+j]=facvert[i*NN+j];
<a name="l00426"></a>00426       }
<a name="l00427"></a>00427       t_cnt2++;
<a name="l00428"></a>00428     }
<a name="l00429"></a>00429   }
<a name="l00430"></a>00430   assert(t_cnt2==gdata-&gt;<a class="code" href="structGridData.html#a0d57327dd6a657273e24613f3edd7fce">n_bnd_fac</a>);
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <span class="comment">/* convert boundary indicators to new boundary node numbers */</span>
<a name="l00433"></a>00433   <span class="keywordtype">int</span> t_cnt3;
<a name="l00434"></a>00434   t_cnt3=0;
<a name="l00435"></a>00435   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>; i++) {
<a name="l00436"></a>00436     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[i]==<a class="code" href="griddata_8h.html#ae002d636437ba3349f6501c36cfb5e02">C_BND</a>) {
<a name="l00437"></a>00437       gdata-&gt;<a class="code" href="structGridData.html#a61acba7bde22d0fdea2069433662f6b5">vertbndg2bnd</a>[i]=t_cnt3++;
<a name="l00438"></a>00438     }
<a name="l00439"></a>00439   }
<a name="l00440"></a>00440   assert(t_cnt3==gdata-&gt;<a class="code" href="structGridData.html#a916cbd12c058654799cd18db685734c5">n_vert_bnd</a>);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   ierr = PetscFree(elefac);CHKERRQ(ierr);
<a name="l00443"></a>00443   ierr = PetscFree(facnb);CHKERRQ(ierr);
<a name="l00444"></a>00444   ierr = PetscFree(facvert);CHKERRQ(ierr);
<a name="l00445"></a>00445 
<a name="l00446"></a>00446   ierr = PetscFree(ia);CHKERRQ(ierr);
<a name="l00447"></a>00447   ierr = PetscFree(ja);CHKERRQ(ierr);
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00451"></a>00451 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

